@echo off
	set crisisDrivePresent=false
	set crisisHelpFlag=false
	set crisisParamaterError=false
	set crisisDriveName=A:
	set crisisCopyOnly=false
	set crisisMakeRecovery=
	set crisisMakeOEMDisk=false


	cls

:cdParmLp
	if '%1'=='' goto cdParmCk
	if '%1'=='A:' goto cdDrvSet
	if '%1'=='a:' goto cdDrvSet
	if '%1'=='B:' goto cdDrvSet
	if '%1'=='b:' goto cdDrvSet
	if '%1'=='/C' goto cdCopyOnly
	if '%1'=='/c' goto cdCopyOnly
	if '%1'=='/R' goto cdMakeRecovery
	if '%1'=='/r' goto cdMakeRecovery
	if '%1'=='/O' goto cdMakeOEMDisk
	if '%1'=='/o' goto cdMakeOEMDisk
	if '%1'=='/?' goto cdFlgSet
	if '%1'=='-?' goto cdFlgSet
	goto cdParmBd


rem======================================================================
rem
rem  Set the Disk drive if specified.
rem
rem======================================================================
:cdDrvSet
	if not '%crisisDrivePresent%'=='false' echo.
	if not '%crisisDrivePresent%'=='false' echo -----     Warning - Extra Paramater "%1" Ignored

	if '%crisisDrivePresent%'=='false' set crisisDriveName=%1
	if '%crisisDrivePresent%'=='false' set crisisDrivePresent=true

	goto cdParmNx

rem======================================================================
rem
rem  Set the Disk Copy Only Flag
rem
rem======================================================================
:cdCopyOnly
	if '%crisisCopyOnly%'=='false' set crisisCopyOnly=true

	goto cdParmNx

rem======================================================================
rem
rem  Set the Disk Make Recovery Flag
rem
rem======================================================================
:cdMakeRecovery
	if '%crisisMakeRecovery%'=='' set crisisMakeRecovery=minidos.sys

	goto cdParmNx

rem======================================================================
rem
rem  Set the Disk Make OEM Disk Flag
rem
rem======================================================================
:cdMakeOEMDisk
	if '%crisisMakeOEMDisk%'=='false' set crisisMakeOEMDisk=true

	goto cdParmNx

rem======================================================================
rem
rem  Set the Disk update mode if specified.
rem
rem======================================================================
:cdFlgSet
	if not '%crisisHelpFlag%'=='false' echo.
	if not '%crisisHelpFlag%'=='false' echo -----     Warning - Extra Paramater "%1" Ignored

	if '%crisisHelpFlag%'=='false' set crisisHelpFlag=true

	goto cdParmNx


rem======================================================================
rem
rem  Display an error message for illegal parameters.
rem
rem======================================================================
:cdParmBd
	echo.
	echo -----     Error - Illegal Parameter "%1"

	set crisisParamaterError=true


rem======================================================================
rem
rem  Check for the next valid paramater.
rem
rem======================================================================
:cdParmNx
	shift

	goto cdParmLp


rem======================================================================
rem
rem  Prevent Disk creation if an error occured.
rem
rem======================================================================
:cdParmCk
	if '%crisisParamaterError%'=='true' goto cdParmSh


rem======================================================================
rem
rem  Display help screen if help is requested.
rem
rem======================================================================
	if '%crisisHelpFlag%'=='true' goto cdParmSh


rem======================================================================
rem
rem  Indicate that the disk will be formated.
rem
rem======================================================================
	if '%crisisCopyOnly%'=='true' goto cdCopyOnly

	cls

	echo.
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo               The Disk in drive %crisisDriveName% is being formatted
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo.

	if '%crisisMakeRecovery%'=='' format /q /s %crisisDriveName%
	if not '%crisisMakeRecovery%'=='' format /q %crisisDriveName%

	if ERRORLEVEL==3 goto cdFmtBrk
	if ERRORLEVEL==4 goto cdFtlFmt
	if ERRORLEVEL==5 goto cdNoProc

	echo.
	pause Press any key to copy the utilities to the Disk...
	goto cddocopy

:cdCopyOnly
	cls

	echo.
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo               The Disk in drive %crisisDriveName% is being cleared
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo.

	attrib +r a:\command.com
	del /q /s a:\*.bin 1>nul 2>nul
	del /q /s a:\*.exe 1>nul 2>nul
	del /q a:\*.rom 1>nul 2>nul
	del /q a:\*.bat 1>nul 2>nul
	del /q a:\oem*. 1>nul 2>nul
	for %%f in (05 06 07 08 09 10 11 12 13 14 15 16 17 18) do rd /q /s 97-41%%f
	
rem======================================================================
rem
rem  Copy the utility files to the boot disk in the required order.
rem
rem======================================================================
:cddocopy
	cls

	echo.
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo               The necessary files are being copied to the Disk
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo.

	call criscopy %crisisMakeRecovery% PHLASH.EXE PLATFORM.BIN BIOS.ROM
	if ERRORLEVEL 1 goto cdDiskError

	if not exist VGABIOS.EXE goto cdnovga

	 call criscopy VGABIOS.EXE
	 if ERRORLEVEL 1 goto cdDiskError

	:cdnovga

	if '%crisisMakeRecovery%' == '' goto cdmakeupdate
	
		makeboot %crisisDriveName%
		if not ERRORLEVEL==0 goto cdMkBErr
		goto cdMakeMinidosOk
		
		
	:cdmakeupdate

rem assuming this is an update disk not a recover disk then we also need...

	call criscopy AUTOEXEC.BAT UPDATE.BAT GETPARTS.EXE CMPPARTS.EXE SETDENV.BAT
	if ERRORLEVEL 1 goto cdDiskError

	if not exist bb.bin goto cdNoBB
		
		call criscopy FORMBIOS.EXE PLATBB.BIN BB.BIN
		rem ...and the bootblock data directories and files
		call _mvbbd.bat

	:cdNoBB
	
Rem EMO Additions for OEM Support

	if not exist oemcust goto cdnocust
	
		call criscopy OEMCUST PLATOEM.BIN
		if ERRORLEVEL 1 goto cdDiskError

	:cdnocust
	
	if '%crisisMakeOEMDisk%'=='false' goto cdnooem

		call criscopy PLATFBD.BIN
		if ERRORLEVEL 1 goto cdDiskError

	:cdnooem

Rem Radisys Additions for prototype testing
	if not exist protmnu.bat goto cdnoprot

		call criscopy PROTMNU.BAT CHOOSE.EXE DISPBBT.BAT DISPBBM.BAT DISPBBP.BAT
		if ERRORLEVEL 1 goto cdDiskError

	:cdnoprot

	echo.
	pause Press any key to exit the Disk creation utility...


rem======================================================================
rem
rem  Signal that the Update Disk has been created.
rem
rem======================================================================
	cls

	echo.
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo               Update diskette on drive %crisisDriveName% successfully created
	echo               Please remove the disk from drive %crisisDriveName%
	echo.
	echo          -----------------------------------------------------------
	echo.

	goto cdclearenv

rem======================================================================
rem
rem  Signal that the Disk has been created.
rem
rem======================================================================
:cdMakeMinidosOk        
	cls

	echo.
	echo.
	echo          -----------------------------------------------------------
	echo.
	echo               Recovery diskette on drive %crisisDriveName% successfully created
	echo               Please remove the disk from drive %crisisDriveName%
	echo.
	echo          -----------------------------------------------------------
	echo.

	goto cdclearenv
	
rem======================================================================
rem
rem  Clear the global variables used by the script file.
rem
rem======================================================================
:cdclearenv
	set crisisDrivePresent=
	if not '%crisisDrivePresent%'=='' goto cdEnvErr

	set crisisHelpFlag=
	if not '%crisisHelpFlag%'=='' goto cdEnvErr

	set crisisDriveName=
	if not '%crisisDriveName%'=='' goto cdEnvErr

	set crisisParamaterError=
	if not '%crisisParamaterError%'=='' goto cdEnvErr

rem======================================================================
rem
rem  Exit from the Disk creation script.
rem
rem======================================================================
	goto cdCrtExt


rem======================================================================
rem
rem  Indicate that the user interrupted the format process.
rem
rem======================================================================
:cdFmtBrk
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - The user interrupted while formatting, the
	echo         Disk was not created.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt


rem======================================================================
rem
rem  Indicate that there was a disk error during the format process.
rem
rem======================================================================
:cdFtlFmt
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - A disk error occured while formatting, the
	echo         Disk was not created.  Check the disk
	echo         for errors or replace the disk with a new 1.44MB
	echo         disk, then try again.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt


rem======================================================================
rem
rem  Indicate that the user waived the format process.
rem
rem======================================================================
:cdNoProc
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - The user choose not to format the disk, the
	echo         Disk was not created.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt

rem======================================================================
rem
rem  Indicate that there was a disk error during the copy process.
rem
rem======================================================================
:cdWrtErr
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - A disk error occured while copying "%crisisCurrentFile%",
	echo         the Disk was not created.  Check the
	echo         disk for errors or replace the disk, then try
	echo         again.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt

rem======================================================================
rem
rem  Desplay the environment variable allocation error message.
rem
rem======================================================================
:cdEnvErr
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - System unable to assign environment variables,
	echo         Increase the main environment space, then try again.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt


rem======================================================================
rem
rem  Desplay the boot sector error message.
rem
rem======================================================================
:cdMkBErr
	echo.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.
	echo Error - System unable to create the custom boot sector.
	echo         Check the disk for errors or replace the disk,
	echo         then try again.
	echo.
	echo !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	echo.

	goto cdCrtExt


rem======================================================================
rem
rem  Indicate the correct usage for the batch file.
rem
rem======================================================================
:cdParmSh
	echo.
	echo      #######################################################################
	echo      #                                                                     #
	echo      #     CRISDISK Usage:                                                 #
	echo      #                                                                     #
	echo      #        CRISDISK [DRIVE:] [/? or -?]                                 #
	echo      #                                                                     #
	echo      #           DRIVE    - The drive (A: or B:) where the disk will be    #
	echo      #                      created  (Default is A:)                       #
	echo      #                                                                     #
	echo      #           /? or -? - Display this help screen                       #
	echo      #           /R       - Create a recovery disk rather than update disk #
	echo      #           /O       - Make this an OEM update disk                   #
	echo      #           /C       - Do not format the disk just copy files.        #
	echo      #                                                                     #
	echo      #######################################################################


rem======================================================================
rem
rem  Exit the batch file.
rem
rem======================================================================
:cdCrtExt
	echo.
	pause Press any key to return to DOS...
	echo.
	echo.
:cdDiskError
